﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;

namespace EF_Flex_CustomDropDown
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexGrid1.Cols["ContactTitle"].Editor = c1DropDownControl1;
            DropDownForm frmChild = new DropDownForm();
            frmChild.Show();
            frmChild.Hide();
        }

        bool Keydwn = false;

        private void c1FlexGrid1_KeyDown(object sender, KeyEventArgs e)
        {
            if (c1FlexGrid1.Col == 4)
            {
                Keydwn = true;
                //Filter records before the DropDown is opened
                ApplyFilter(sender, e.KeyData.ToString());
            }
        }
        bool flag = false;

        private void c1FlexGrid1_KeyUpEdit(object sender, C1.Win.C1FlexGrid.KeyEditEventArgs e)
        {
            if (Keydwn == true)
            {
                SendKeys.Send("{BACKSPACE}");
                flag = true;
            }
              
            if (c1FlexGrid1.Col == 4)
            {
                  if (e.KeyCode == Keys.Back)
                {
                    flag = true;
                    C1.Win.Data.Entities.EntityViewSourceCollection vs = ((C1.Win.Data.Entities.C1DataSource)((C1.Win.C1FlexGrid.C1FlexGrid)this.c1DropDownControl1.DropDownForm.Controls[0]).DataSource).ViewSources;
                    vs[0].FilterDescriptors.Clear();
                }
                else
                {
                    //Open the DropDown after a character is typed
                    c1DropDownControl1.OpenDropDown();
                    if (flag == true)
                        ApplyFilter(sender, e.KeyData.ToString());
                }
            }
        }

        private void c1FlexGrid1_SelChange(object sender, EventArgs e)
        {
            if (c1FlexGrid1.Col == 4)
            {
                //If the Selected cell changes
                //Clear all the previously set filter Descriptors 
                C1.Win.Data.Entities.EntityViewSourceCollection vs = ((C1.Win.Data.Entities.C1DataSource)((C1.Win.C1FlexGrid.C1FlexGrid)this.c1DropDownControl1.DropDownForm.Controls[0]).DataSource).ViewSources;
                vs[0].FilterDescriptors.Clear();
            }
        }

        //Apply Filtering in the ViewSource of the DropDown C1FlexGrid bound to C1DataSource
        private void ApplyFilter(object sender, string value)
        {
            
            C1.Win.Data.Entities.EntityViewSourceCollection vs = ((C1.Win.Data.Entities.C1DataSource)((C1.Win.C1FlexGrid.C1FlexGrid)this.c1DropDownControl1.DropDownForm.Controls[0]).DataSource).ViewSources;

            vs[0].FilterDescriptors.Clear();
            
            //Create filterdescriptors to perform filtering in the ViewSource
            C1.Data.DataSource.FilterDescriptor fd = new C1.Data.DataSource.FilterDescriptor();

            //Column on which Filetring has to be applied
            fd.PropertyPath = "Title";
            //Records which are to be filtered
            fd.Value = value;
           
            fd.Operator = C1.Data.DataSource.FilterOperator.StartsWith;
            vs[0].FilterDescriptors.Add(fd);

            
        }

    }
}
